using System;
using System.IO;
using System.Runtime.InteropServices;

namespace DBurstin.GrowingIDisposable
{
    public class ResourceOwner : IDisposable
    {
        protected IntPtr AnUnmanagedResource = Marshal.StringToCoTaskMemAuto("Foo");
        protected MemoryStream ADisposableResource = new MemoryStream();
        private bool _disposed;

        ~ResourceOwner()
        {
            Dispose(false);
        }

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }

        protected virtual void Dispose(bool disposing)
        {
            if (_disposed) return;

            if (disposing)
            {
                DisposeDisposableResources();
            }
            
            FreeUnmanagedResources();

            _disposed = true;
        }

        public void PublicMethodThatUsesFinalizableResources()
        {
            if (_disposed) throw new ObjectDisposedException(GetType().FullName);
            
            SomeCodeThatUsesFinalizableResources();
        } 
        
        private void FreeUnmanagedResources()
        {
            Marshal.FreeCoTaskMem(AnUnmanagedResource);
        }

        private void DisposeDisposableResources()
        {
            ADisposableResource.Dispose();
        }


        private void SomeCodeThatUsesFinalizableResources()
        {
            Marshal.PtrToStringAuto(AnUnmanagedResource);
        }
    }
}