using System;
using System.Runtime.InteropServices;

namespace DBurstin.GrowingIDisposable
{
    public class ResourceSpy : ResourceOwner
    {
        private bool _disposeWasCalledWithTrue;
        private bool _disposeWasCalledWithFalse;

        public void MimicFinalizer()
        {
            Dispose(false);
        }

        public bool UnmanagedResourcesHaveBeenReleased
        {
            get
            {
                var referencedString = Marshal.PtrToStringAuto(AnUnmanagedResource);
                return referencedString != "Foo";
            }
        }

        public bool DisposableResourcesHaveBeenDisposed
        {
            get
            {
                try
                {
                    ADisposableResource.ReadByte();
                }
                catch (ObjectDisposedException)
                {
                    return true;
                }
                return false;
            }
        }

        protected override void Dispose(bool disposing)
        {
            _disposeWasCalledWithTrue = disposing;
            _disposeWasCalledWithFalse = !disposing;
            base.Dispose(disposing);
        }

        public bool DisposeWasCalled(bool expected)
        {
            return expected ? _disposeWasCalledWithTrue : _disposeWasCalledWithFalse;
        }
    }
}